#include <inttypes.h>
#include <stdio.h>
#ifndef UTILITIES_HPP
#define UTILITIES_HPP
#include <string.h>

extern unsigned long mersenne_genrand_int32(void);

class IDString
{
public:
  IDString()
  {
    uint32_t a, b, c, d;
    a = mersenne_genrand_int32();
    b = mersenne_genrand_int32();
    c = mersenne_genrand_int32();
    d = mersenne_genrand_int32();
    sprintf(mIDString, "%08X-%04X-%04X-%04X-%04X%08X",
            a, (b & 0xFFFF), (b >> 16) & 0xFFFF,
            c & 0xFFFF, (c >> 16) & 0xFFFF, d);
  }

  char* cloneID()
  {
    return strdup(mIDString);
  }
private:
  char mIDString[37];
};

#define IMPL_ID \
private: \
  IDString mID; \
public: \
  char* objid(void) \
  { \
    return mID.cloneID(); \
  }
#define IMPL_REFCOUNT \
private: \
  uint32_t refcount; \
public: \
  void add_ref() \
  { \
    refcount++; \
  } \
  void release_ref() \
  { \
    refcount--; \
    if (refcount == 0) \
    { \
      PortableServer::ObjectId_var oid = poa->servant_to_id(this); \
      poa->deactivate_object(oid); \
    } \
  }
#define IMPL_QIHEAD \
  XPCOM::IObject_ptr \
  query_interface(const char* iface) \
  { \
    if (!strcmp(iface, "XPCOM::IObject")

#define IMPL_QIENTRY(name) \
        || !strcmp(iface, #name)
#define IMPL_QITAIL \
       ) \
      add_ref(); \
      return _this(); \
    return NULL; \
  }

#define IMPL_QI0 \
  IMPL_QIHEAD \
  IMPL_QITAIL
#define IMPL_QI1(x1) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QITAIL
#define IMPL_QI2(x1, x2) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QIENTRY(x2) \
  IMPL_QITAIL
#define IMPL_QI3(x1, x2, x3) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QIENTRY(x2) \
  IMPL_QIENTRY(x3) \
  IMPL_QITAIL
#define IMPL_QI4(x1, x2, x3, x4) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QIENTRY(x2) \
  IMPL_QIENTRY(x3) \
  IMPL_QIENTRY(x4) \
  IMPL_QITAIL
#define IMPL_QI5(x1, x2, x3, x4, x5) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QIENTRY(x2) \
  IMPL_QIENTRY(x3) \
  IMPL_QIENTRY(x4) \
  IMPL_QIENTRY(x5) \
  IMPL_QITAIL
#define IMPL_QI6(x1, x2, x3, x4, x5, x6) \
  IMPL_QIHEAD \
  IMPL_QIENTRY(x1) \
  IMPL_QIENTRY(x2) \
  IMPL_QIENTRY(x3) \
  IMPL_QIENTRY(x4) \
  IMPL_QIENTRY(x5) \
  IMPL_QIENTRY(x6) \
  IMPL_QITAIL

#define IMPL_XPCOM0 \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI0
#define IMPL_XPCOM1(x1) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI1(x1)
#define IMPL_XPCOM2(x1, x2) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI2(x1, x2)
#define IMPL_XPCOM3(x1, x2, x3) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI3(x1, x2, x3)
#define IMPL_XPCOM4(x1, x2, x3, x4) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI4(x1, x2, x3, x4)
#define IMPL_XPCOM5(x1, x2, x3, x4, x5) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI5(x1, x2, x3, x4, x5)
#define IMPL_XPCOM6(x1, x2, x3, x4, x5, x6) \
  IMPL_ID \
  IMPL_REFCOUNT \
  IMPL_QI6(x1, x2, x3, x4, x5, x6)
#endif // UTILITIES_HPP
